/*!
  @file ExceptionBlockIP.h 
  @brief Definition of ExceptionBlockIP
*/

#ifndef EXCEPTIONBLOCKIP_H
#define EXCEPTIONBLOCKIP_H

#include <exception>
#include <string>

using namespace std;

enum TYPE_ERROR {OUT_OF_MEMORY, NOIJA, NOIJA_GENERAL, CHOLMOD_NOT_IMPLEMENTED, SEMIDEFINITE, ORDMMD_PROBLEMS, SFINIT_PROBLEMS, SYMFCT_PROBLEMS,
                 GET_ILNZ_IFILLIN_GENERAL_PROBLEMS, GET_ILNZ_IFILLIN_NETWORK_PROBLEMS, BLKFCT_PROBLEMS, COLUMN_OUT_OF_RANGE, ROW_OUT_OF_RANGE,
                 HESS_NOT_ZERO, FOBJ_NULL, ZERO_BLOCKS, N_NULL, L_COLUMNS, L_ROWS, SAME_N_CONS, SAME_NL_FREE_VAR,
                 SAME_NL_LB_INF_VAR, NONLINMPS, OPEN_FILE_WRITE, OPEN_FILE_READ, BLOCKIP_WRONG_FORMAT, MPS_WRONG_FORMAT, MPS_CONSTANT_DEF, MPS_CONTANT_CONS, 
                 MPS_SLACK_WITH_NO_LIN, MPS_BLOCK, MPS_CONS, MPS_VAR, MPS_VAR_REP, MPS_LIN_COST_REP, MPS_CONS_VAR_REP, MPS_CONS_VAR_BLOCK, MPS_LINK_WITHOUT_SLACK, 
                 MPS_SLACK_ALREADY_DEFINED, MPS_SLACK_COEF, MPS_FREE_CONS_BOUNDS, MPS_RHS_DEF, MPS_RHS_NOT_DEF, MPS_RANGES_DEF, MPS_BOUNDS_DEF, 
                 MPS_CONSTANT_BOUNDS, MPS_QUADOBJ, MPS_QUADOBJ_DEF,NOT_FOR_THIS_MATRIX_TYPE,
                 QCOST_NOT_SEMIDEF,TYPE_STARTPOINT_TODO, MEHROTRA_NOT_IMPLEMENTED, HYBRIDPCG_NOT_IMPLEMENTED, 
		 INFINITY_RHS};
                 
//! Class for BlockIP exceptions
class ExceptionBlockIP : public exception {
  public:
    TYPE_ERROR error;
    string file;
    int line;
    string message;
    ExceptionBlockIP(TYPE_ERROR error) throw();
    ExceptionBlockIP(TYPE_ERROR error, string file) throw();
    ExceptionBlockIP(TYPE_ERROR error, string file, int line) throw();
    ~ExceptionBlockIP() throw();
    const char* what() const throw();
  private:
    void setMessage();
};

#endif //EXCEPTIONBLOCKIP_H
