#include "ExceptionBlockIPInterface.h"
#include <iostream>
#include <sstream>

using namespace std;

ExceptionBlockIPInterface::ExceptionBlockIPInterface(TYPE_ERROR error) throw() {
  this->error= error;
  this->file= "";
}

ExceptionBlockIPInterface::ExceptionBlockIPInterface(TYPE_ERROR error, string file, int line) throw() {
  this->error= error;
  this->file= file;
  this->line= line;
}

ExceptionBlockIPInterface::~ExceptionBlockIPInterface() throw() {}

const char* ExceptionBlockIPInterface::what() const throw() {
  ostringstream oss;
  oss << "ERROR: ";
  switch (error) {
    case OSI_INTERFACE_NOT_AVAILABLE:
      oss << "This solver is not available, check if OsiInterface is installed.";
      break;
    case SOLVER_NOT_DEFINED:
      oss << "Before load a problem you have to define the solver to use.";
      break;
    case NONLINEAR_NON_ACCEPTED:
      oss << "This solver does not accept a non-linear objective function from ampl files.";
      break;
    case CREATE_TMP_FILES:
      oss << "Unable to create temporal files.";
      break;
    case OPEN_TMP_FILES:
      oss << "Unable to open temporal file.";
      break;
    case SOLUTION_FILE:
      oss << "Unable to create or open the solution file.";
      break;
  }
  if (file != "") oss << " At " << file << ":" << line;
  return oss.str().c_str();
}