/*!
  @file ExceptionBlockIPInterface.h 
  @brief Definition of ExceptionBlockIPInterface
*/

#ifndef EXCEPTION_BLOCKIP_INTERFACE
#define EXCEPTION_BLOCKIP_INTERFACE

#ifndef EXPDLL
#ifdef WIN32
#ifdef BLOCKIP_INTERFACE_EXPORTS
#define EXPDLL __declspec(dllexport)
#else
#define EXPDLL __declspec(dllimport)
#endif //BLOCKIP_INTERFACE_EXPORTS
#else
#define EXPDLL 
#endif //WIN32
#endif //EXPDLL

#include <exception>
#include <string>

using namespace std;

//! Class for BlockIPInterface exceptions
class EXPDLL ExceptionBlockIPInterface : public exception {
  public:
    enum TYPE_ERROR {OSI_INTERFACE_NOT_AVAILABLE, SOLVER_NOT_DEFINED, NONLINEAR_NON_ACCEPTED,
                     CREATE_TMP_FILES, OPEN_TMP_FILES, SOLUTION_FILE};
  
    TYPE_ERROR error;
    string file;
    int line;
    ExceptionBlockIPInterface(TYPE_ERROR error) throw();
    ExceptionBlockIPInterface(TYPE_ERROR error, string file, int line) throw();
    ~ExceptionBlockIPInterface() throw();
    const char* what() const throw();
};

#endif //EXCEPTION_BLOCKIP_INTERFACE