#include "ExceptionSMLBlockIP.h"
#include <iostream>
#include <sstream>

using namespace std;

ExceptionSMLBlockIP::ExceptionSMLBlockIP(TYPE_ERROR error) throw() {
  this->error= error;
  this->file= "";
}

ExceptionSMLBlockIP::ExceptionSMLBlockIP(TYPE_ERROR error, string file, int line) throw() {
  this->error= error;
  this->file= file;
  this->line= line;
}

ExceptionSMLBlockIP::~ExceptionSMLBlockIP() throw() {}

const char* ExceptionSMLBlockIP::what() const throw() {
  ostringstream oss;
  switch (error) {
    case NONLINEAR_CONSTRAINTS:
      oss << "BlockIP does not accept nonlinear constraints.";
      break;
    case WRONG_QUADRATICS:
      oss << "BlockIP does not accept quadratic terms with Hessian not diagonal.";
      break;
    case NON_ZERO_SLACK_LB:
      oss << "Lower bounds of variables from Slacks Block must be 0.";
      break;
    case NEGATIVE_SLACK_UB:
      oss << "Upper bounds of variables from Slacks Block must be positive.";
      break;
    case NON_EQUAL_COMMODITIES:
      oss << "Restrictions from Slacks block must be equality restrictions.";
      break;
    case WRONG_SLACK_COEF:
      oss << "Slacks block cannot have any restriction.";
      break;
    case HESS_NOT_SEMIDEF:
      oss << "The Hessian matrix of the objective function must be positive semidefinite.";
      break;
    case HESS_NOT_DIAG:
      oss << "The Hessian matrix of the objective function must be positive diagonal.";
      break;
    case LIN_SLACKS:
      oss << "Each slack must be related to one linking contraint.";
  }
  if (file != "") oss << " At " << file << ":" << line;
  return oss.str().c_str();
}