/*!
  @file ExceptionSMLBlockIP.h 
  @brief Definition of ExceptionSMLBlockIP
*/

#ifndef EXCEPTIONSMLBLOCKIP_H
#define EXCEPTIONSMLBLOCKIP_H

#include <exception>
#include <string>

using namespace std;

//! Class for SMLBlockIP exceptions
class ExceptionSMLBlockIP : public exception {
  public:
    enum TYPE_ERROR {NONLINEAR_CONSTRAINTS, WRONG_QUADRATICS, NON_ZERO_SLACK_LB, 
    NEGATIVE_SLACK_UB, NON_EQUAL_COMMODITIES, WRONG_SLACK_COEF, HESS_NOT_SEMIDEF, HESS_NOT_DIAG,
    LIN_SLACKS, SYNTAX_ERROR};
  
    TYPE_ERROR error;
    string file;
    int line;
    ExceptionSMLBlockIP(TYPE_ERROR error) throw();
    ExceptionSMLBlockIP(TYPE_ERROR error, string file, int line) throw();
    ~ExceptionSMLBlockIP() throw();
    const char* what() const throw();
};

#endif //EXCEPTIONSMLBLOCKIP_H