
# start of model 

param T;
set TIME ordered := 0 .. T;
set NODES;
param Parent{NODES} symbolic;
param Probs{NODES};
set ASSETS;
param Price{ASSETS};
param Return{ASSETS,NODES};
param Liability{TIME};
param InitialWealth;
param Gamma;
var makemodelrun >= 0;

# start of model alm0

var alm0_x_hold{ASSETS} >= 0;
var alm0_cash >= 0;
set alm0_rootset := {this_nd in NODES: Parent[this_nd] == "null"};
set alm0_ind0 := {this_nd in NODES: Parent[this_nd] in alm0_rootset};
set alm0_ind0_SUB within alm0_ind0;

# start of model alm0_1

var alm0_1_x_hold{ix0 in alm0_ind0_SUB,ASSETS} >= 0;
var alm0_1_cash{ix0 in alm0_ind0_SUB} >= 0;
var alm0_1_x_bought{ix0 in alm0_ind0_SUB,ASSETS} >= 0;
var alm0_1_x_sold{ix0 in alm0_ind0_SUB,ASSETS} >= 0;
subject to alm0_1_Inventory{ix0 in alm0_ind0_SUB,j in ASSETS}:
    alm0_1_x_hold[ix0,j] = (1 + Return[j,ix0]) * alm0_x_hold[j] + alm0_1_x_bought[ix0,j] - alm0_1_x_sold[ix0,j];
subject to alm0_1_CashBalance{ix0 in alm0_ind0_SUB}:
    Liability[1] + alm0_1_cash[ix0] + (1 + Gamma) * sum {j in ASSETS}Price[j] * alm0_1_x_bought[ix0,j] = alm0_cash + (1 - Gamma) * sum {j in ASSETS}Price[j] * alm0_1_x_sold[ix0,j];
set alm0_1_ind1{ix0 in alm0_ind0_SUB} := {this_nd in NODES: Parent[this_nd] == ix0};
minimize alm0_1_dummy{ix0 in alm0_ind0_SUB}:
    sum {dum0 in ASSETS}alm0_1_x_hold[ix0,dum0] + alm0_1_cash[ix0] + sum {dum0 in ASSETS}alm0_1_x_bought[ix0,dum0] + sum {dum0 in ASSETS}alm0_1_x_sold[ix0,dum0];
