
# start of model 

param T;
set TIME ordered := 0 .. T;
set NODES;
param Parent{NODES} symbolic;
param Probs{NODES};
set ASSETS;
param Price{ASSETS};
param Return{ASSETS,NODES};
param Liability{TIME};
param InitialWealth;
param Gamma;
var makemodelrun >= 0;

# start of model alm0

var alm0_x_hold{ASSETS} >= 0;
var alm0_cash >= 0;
set alm0_rootset := {this_nd in NODES: Parent[this_nd] == "null"};
set alm0_ind0 := {this_nd in NODES: Parent[this_nd] in alm0_rootset};
set alm0_ind0_SUB within alm0_ind0;

# start of model alm0_1

var alm0_1_x_hold{ix0 in alm0_ind0_SUB,ASSETS} >= 0;
var alm0_1_cash{ix0 in alm0_ind0_SUB} >= 0;
var alm0_1_x_bought{ix0 in alm0_ind0_SUB,ASSETS} >= 0;
var alm0_1_x_sold{ix0 in alm0_ind0_SUB,ASSETS} >= 0;
set alm0_1_ind1{ix0 in alm0_ind0_SUB} := {this_nd in NODES: Parent[this_nd] == ix0};
set alm0_1_ind1_SUB{ix0 in alm0_ind0_SUB} within alm0_1_ind1[ix0];

# start of model alm0_1_2

var alm0_1_2_x_hold{ix0 in alm0_ind0_SUB,ix1 in alm0_1_ind1_SUB[ix0],ASSETS} >= 0;
var alm0_1_2_cash{ix0 in alm0_ind0_SUB,ix1 in alm0_1_ind1_SUB[ix0]} >= 0;
var alm0_1_2_x_bought{ix0 in alm0_ind0_SUB,ix1 in alm0_1_ind1_SUB[ix0],ASSETS} >= 0;
var alm0_1_2_x_sold{ix0 in alm0_ind0_SUB,ix1 in alm0_1_ind1_SUB[ix0],ASSETS} >= 0;
subject to alm0_1_2_Inventory{ix0 in alm0_ind0_SUB,ix1 in alm0_1_ind1_SUB[ix0],j in ASSETS}:
    alm0_1_2_x_hold[ix0,ix1,j] = (1 + Return[j,ix1]) * alm0_1_x_hold[ix0,j] + alm0_1_2_x_bought[ix0,ix1,j] - alm0_1_2_x_sold[ix0,ix1,j];
subject to alm0_1_2_CashBalance{ix0 in alm0_ind0_SUB,ix1 in alm0_1_ind1_SUB[ix0]}:
    Liability[2] + alm0_1_2_cash[ix0,ix1] + (1 + Gamma) * sum {j in ASSETS}Price[j] * alm0_1_2_x_bought[ix0,ix1,j] = alm0_1_cash[ix0] + (1 - Gamma) * sum {j in ASSETS}Price[j] * alm0_1_2_x_sold[ix0,ix1,j];
var alm0_1_2_wealth{ix0 in alm0_ind0_SUB,ix1 in alm0_1_ind1_SUB[ix0]} >= 0;
subject to alm0_1_2_FinalWealth{ix0 in alm0_ind0_SUB,ix1 in alm0_1_ind1_SUB[ix0]}:
    alm0_1_2_wealth[ix0,ix1] = sum {j in ASSETS}Price[j] * alm0_1_2_x_hold[ix0,ix1,j] + alm0_1_2_cash[ix0,ix1];
maximize alm0_1_2_objFunc{ix0 in alm0_ind0_SUB,ix1 in alm0_1_ind1_SUB[ix0]}:
    Probs[ix0] * Probs[ix1] * (alm0_1_2_wealth[ix0,ix1]);
set alm0_1_2_ind2{ix0 in alm0_ind0_SUB,ix1 in alm0_1_ind1_SUB[ix0]} := {this_nd in NODES: Parent[this_nd] == ix1};
minimize alm0_1_2_dummy{ix0 in alm0_ind0_SUB,ix1 in alm0_1_ind1_SUB[ix0]}:
    sum {dum0 in ASSETS}alm0_1_2_x_hold[ix0,ix1,dum0] + alm0_1_2_cash[ix0,ix1] + sum {dum0 in ASSETS}alm0_1_2_x_bought[ix0,ix1,dum0] + sum {dum0 in ASSETS}alm0_1_2_x_sold[ix0,ix1,dum0] + alm0_1_2_wealth[ix0,ix1];
